Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 100)
@@ -17,12 +17,18 @@
 import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
 import com.framsticks.params.EventListener;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.util.*;
 import java.util.regex.Matcher;
+
+import javax.annotation.Nonnull;
+import javax.annotation.Nullable;
+
 import com.framsticks.util.dispatching.RunAt;
 
@@ -32,5 +38,5 @@
 public class ClientSideManagedConnection extends ManagedConnection {
 
-	private final static Logger log = Logger.getLogger(ClientSideManagedConnection.class);
+	private final static Logger log = LogManager.getLogger(ClientSideManagedConnection.class);
 
 	private final List<Runnable> applicationRequestsBuffer = new LinkedList<>();
@@ -60,42 +66,23 @@
 
 
-	private static abstract class InboundMessage {
-		protected String currentFilePath;
-		protected List<String> currentFileContent;
-		protected final List<File> files = new ArrayList<File>();
-
-		public abstract void eof();
-
-		protected void initCurrentFile(String path) {
-			currentFileContent = new LinkedList<String>();
-			currentFilePath = path;
-		}
-
-		protected void finishCurrentFile() {
-			if (currentFileContent == null) {
-				return;
-			}
-			files.add(new File(currentFilePath, new ListSource(currentFileContent)));
-			currentFilePath = null;
-			currentFileContent = null;
-		}
-
-		public abstract void startFile(String path);
-
-		public final void addLine(String line) {
-			assert line != null;
-			assert currentFileContent != null;
-			currentFileContent.add(line);
-		}
-
-		public List<File> getFiles() {
-			return files;
-		}
-	}
 
 	protected List<String> readFileContent() {
 		List<String> content = new LinkedList<String>();
 		String line;
-		while (!(line = getLine()).startsWith("eof")) {
+		boolean longValue = false;
+		while (true) {
+			line = getLine();
+			if (longValue) {
+				if (line.endsWith("~") && !line.endsWith("\\~")) {
+					longValue = false;
+				}
+			} else {
+				if (line.equals("eof")) {
+					break;
+				}
+				if (line.endsWith(":~")) {
+					longValue = true;
+				}
+			}
 			content.add(line);
 		}
@@ -103,23 +90,13 @@
 	}
 
-	private static class SentQuery<C> extends InboundMessage {
+	private static class SentQuery<C> {
+
 		Request request;
 		ClientSideResponseFuture callback;
 		Dispatcher<C> dispatcher;
-
-		public void startFile(String path) {
-			finishCurrentFile();
-			if (!Strings.notEmpty(path)) {
-				assert request instanceof ApplicationRequest;
-				path = ((ApplicationRequest) request).getPath();
-			}
-			Strings.assureNotEmpty(path);
-			initCurrentFile(path);
-		}
-
-		public void eof() {
-			assert Strings.notEmpty(currentFilePath);
-			finishCurrentFile();
-			//no-operation
+		protected final List<File> files = new ArrayList<File>();
+
+		public List<File> getFiles() {
+			return files;
 		}
 
@@ -169,6 +146,5 @@
 
 		if (getState().ordinal() > JoinableState.RUNNING.ordinal()) {
-			log.fatal("not connected");
-			return;
+			throw new FramsticksException().msg("connection is not connected").arg("connection", this);
 		}
 
@@ -211,5 +187,5 @@
 				putLine(out);
 				flushOut();
-				log.debug("sending query: " + out);
+				log.debug("sending query: {}", out);
 
 			}
@@ -217,5 +193,5 @@
 		/*
 		synchronized (this) {
-			log.debug("queueing query: " + query);
+			log.debug("queueing query: {}", query);
 			queryQueue.offer(sentQuery);
 			notifyAll();
@@ -253,17 +229,22 @@
 	}
 
-	private synchronized SentQuery<?> fetchQuery(Integer id, boolean remove) {
-		if (id == null) {
-			if (requestIdEnabled) {
-				return null;
-			}
-			SentQuery<?> result = currentlySentQuery;
-			if (remove) {
-				currentlySentQuery = null;
-				notifyAll();
-			}
-			return result;
-		}
-		if (queryMap.containsKey(id)) {
+	private synchronized @Nonnull SentQuery<?> fetchQuery(@Nullable Integer id, boolean remove) {
+		try {
+			if (id == null) {
+				if (requestIdEnabled) {
+					throw new FramsticksException().msg("request_id is enabled and id is missing");
+				}
+				SentQuery<?> result = currentlySentQuery;
+				if (remove) {
+					currentlySentQuery = null;
+					notifyAll();
+				}
+				return result;
+			}
+
+			if (!queryMap.containsKey(id)) {
+				throw new FramsticksException().msg("id is unknown").arg("id", id);
+			}
+
 			SentQuery<?> result = queryMap.get(id);
 			if (remove) {
@@ -271,23 +252,11 @@
 			}
 			return result;
-		}
-		return null;
+
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("failed to match response to sent query").cause(e);
+		}
 	}
 
 	private int nextQueryId = 0;
-
-	protected void processMessage(InboundMessage inboundMessage) {
-		if (inboundMessage == null) {
-			log.error("failed to use any inbound message");
-			return;
-		}
-
-		String line;
-		while (!(line = getLine()).startsWith("eof")) {
-			// log.debug("line: " + line);
-			inboundMessage.addLine(line);
-		}
-		inboundMessage.eof();
-	}
 
 	protected void processEvent(String rest) {
@@ -303,5 +272,5 @@
 		String eventCalleePath = Request.takeGroup(rest, matcher, 2).toString();
 		final File file = new File("", new ListSource(readFileContent()));
-		log.debug("firing event " + eventObjectPath);
+		log.debug("firing event {}", eventObjectPath);
 		EventListener<File> listener;
 		synchronized (registeredListeners) {
@@ -314,29 +283,50 @@
 	}
 
-	protected void processMessageStartingWith(String line) {
+	protected void processFile(Pair<Integer, CharSequence> rest) {
+		final SentQuery<?> sentQuery = fetchQuery(rest.first, false);
+
+		String currentFilePath = rest.second.toString();
+		if (!Strings.notEmpty(currentFilePath)) {
+			currentFilePath = Casting.throwCast(ApplicationRequest.class, sentQuery.request).getPath();
+		}
+
+		sentQuery.files.add(new File(currentFilePath, new ListSource(readFileContent())));
+
+	}
+
+	protected void processMessageStartingWith(final String header) {
 		try {
-			Pair<CharSequence, CharSequence> command = Request.takeIdentifier(line);
-			if (command.first.equals("event")) {
+			final Pair<CharSequence, CharSequence> command = Request.takeIdentifier(header);
+			if (command == null) {
+				throw new FramsticksException().msg("failed to parse command");
+			}
+			final CharSequence keyword = command.first;
+			if (keyword.equals("event")) {
 				processEvent(command.second.toString());
 				return;
 			}
-			Pair<Integer, CharSequence> rest = takeRequestId(command.second);
-
-			if (command.first.equals("file")) {
-				SentQuery<?> sentQuery = fetchQuery(rest.first, false);
-				sentQuery.startFile(rest.second.toString());
-				processMessage(sentQuery);
+
+			final Pair<Integer, CharSequence> rest = takeRequestId(command.second);
+			if (rest == null) {
+				throw new FramsticksException().msg("failed to parse optional id and remainder");
+			}
+
+			if (keyword.equals("file")) {
+				processFile(rest);
 				return;
 			}
-
-			SentQuery<?> sentQuery = fetchQuery(rest.first, true);
-			if (sentQuery == null) {
+			if (keyword.equals("ok") || keyword.equals("error")) {
+
+				final SentQuery<?> sentQuery = fetchQuery(rest.first, true);
+
+				log.debug("parsing response for request {}", sentQuery);
+
+				sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second.toString(), sentQuery.getFiles()));
 				return;
 			}
-			log.debug("parsing response for request " + sentQuery);
-
-			sentQuery.dispatchResponseProcess(new Response(command.first.equals("ok"), rest.second.toString(), sentQuery.getFiles()));
+
+			throw new FramsticksException().msg("unknown command keyword").arg("keyword", keyword);
 		} catch (FramsticksException e) {
-			throw new FramsticksException().msg("failed to process message").arg("starting with line", line).cause(e);
+			throw new FramsticksException().msg("failed to process message").arg("starting with line", header).cause(e);
 		}
 	}
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 100)
@@ -8,6 +8,7 @@
 import com.framsticks.util.lang.Strings;
 
-import org.apache.log4j.Level;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Level;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import java.io.BufferedReader;
 import java.io.IOException;
@@ -22,5 +23,7 @@
 
 import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -32,7 +35,7 @@
 
 @FramsClassAnnotation
-public abstract class Connection extends AbstractJoinable implements JoinableParent {
-
-	protected final static Logger log = Logger.getLogger(Connection.class);
+public abstract class Connection extends AbstractJoinable implements JoinableParent, ExceptionResultHandler {
+
+	protected final static Logger log = LogManager.getLogger(Connection.class);
 
 	private PrintWriter output = null;
@@ -48,4 +51,6 @@
 	protected final JoinableCollection<Thread<Connection>> threads = new JoinableCollection<>();
 	protected final Set<ConnectionListener> listeners = new HashSet<>();
+
+	protected ExceptionResultHandler exceptionHandler = ThrowExceptionHandler.getInstance();
 
 	/**
@@ -161,4 +166,6 @@
 			try {
 				processNextInputBatch();
+			} catch (FramsticksException e) {
+				handle(e);
 			} catch (Exception e) {
 				log.log(isRunning() ? Level.ERROR : Level.DEBUG, "caught exception: ", e);
@@ -183,6 +190,4 @@
 	}
 
-
-
 	@Override
 	protected void joinableFinish() {
@@ -197,5 +202,4 @@
 				input = null;
 			}
-
 
 			if (socket != null) {
@@ -250,5 +254,4 @@
 	}
 
-
 	@Override
 	protected void joinableJoin() throws InterruptedException {
@@ -258,14 +261,14 @@
 	protected static void startClientConnection(Connection connection) {
 		while (connection.isRunning() && !connection.isConnected()) {
-			log.debug("connecting to " + connection.address);
+			log.debug("connecting to {}", connection.address);
 			try {
 				connection.socket = new Socket(connection.getAddressObject().getHostName(), connection.getAddressObject().getPort());
 			} catch (IOException e) {
-				log.info(connection + " failed to connect (retrying): " + e);
+				log.info("{} failed to connect (retrying): ", connection, e);
 				Dispatching.sleep(0.5);
 			}
 		}
 
-		log.debug(connection + " connected");
+		log.debug("{} connected", connection);
 		try {
 			connection.socket.setSoTimeout(500);
@@ -288,5 +291,4 @@
 	}
 
-
 	/**
 	 * @return the listeners
@@ -294,4 +296,18 @@
 	public Collection<ConnectionListener> getListeners() {
 		return listeners;
+	}
+
+	/**
+	 * @return the handler
+	 */
+	public ExceptionResultHandler getExceptionHandler() {
+		return exceptionHandler;
+	}
+
+	/**
+	 * @param handler the handler to set
+	 */
+	public void setExceptionHandler(ExceptionResultHandler handler) {
+		this.exceptionHandler = handler;
 	}
 
@@ -301,3 +317,17 @@
 	}
 
+	@Override
+	public void handle(FramsticksException exception) {
+		exceptionHandler.handle(exception);
+	}
+
+	public Dispatcher<Connection> getReceiverDispatcher() {
+		return receiverThread;
+	}
+
+	public Dispatcher<Connection> getSenderDispatcher() {
+		return senderThread;
+	}
+
+
 }
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 100)
@@ -8,5 +8,6 @@
 import com.framsticks.util.lang.Strings;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.net.Socket;
@@ -18,5 +19,5 @@
 public class ServerSideManagedConnection extends ManagedConnection {
 
-	private final static Logger log = Logger.getLogger(ServerSideManagedConnection.class);
+	private final static Logger log = LogManager.getLogger(ServerSideManagedConnection.class);
 
 	protected final RequestHandler requestHandler;
@@ -64,5 +65,5 @@
 
 		}
-		log.error("unhandled request: " + request);
+		log.error("unhandled request: {}", request);
 		responseCallback.pass(new Response(false, "unhandled", null));
 	}
@@ -123,5 +124,5 @@
 
 			if (log.isTraceEnabled()) {
-				log.trace("read request: " + request);
+				log.trace("read request: {}", request);
 			}
 
Index: java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 100)
@@ -4,5 +4,5 @@
 import com.framsticks.communication.Response;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
 
 /**
Index: java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 100)
@@ -1,9 +1,13 @@
 package com.framsticks.core;
 
+import java.util.Map;
+
 import javax.annotation.Nonnull;
 
-import org.apache.log4j.Logger;
-
-import com.framsticks.params.AccessInterface;
+import org.apache.commons.collections.map.ReferenceIdentityMap;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
@@ -14,4 +18,5 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
@@ -25,4 +30,5 @@
 import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
+import com.framsticks.util.lang.Casting;
 
 /**
@@ -32,5 +38,5 @@
 public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent {
 
-	private static final Logger log = Logger.getLogger(AbstractTree.class);
+	private static final Logger log = LogManager.getLogger(AbstractTree.class);
 
 	private Node root = null;
@@ -45,5 +51,5 @@
 		}
 		root = new Node(this, param, null);
-		log.debug("assigned root type: " + root);
+		log.debug("assigned root type: {}", root);
 	}
 
@@ -57,5 +63,5 @@
 		}
 		root = new Node(this, root.getParam(), object);
-		log.debug("assigned root object: " + root);
+		log.debug("assigned root object: {}", root);
 	}
 
@@ -93,5 +99,5 @@
 
 	@Override
-	public @Nonnull AccessInterface prepareAccess(CompositeParam param) {
+	public @Nonnull Access prepareAccess(CompositeParam param) {
 		return registry.prepareAccess(param);
 	}
@@ -104,5 +110,5 @@
 	@AutoAppendAnnotation
 	public void usePackage(ParamsPackage paramsPackage) {
-		log.debug("using package " + paramsPackage + " in tree " + this);
+		log.debug("using package {} in tree {}", paramsPackage, this);
 		paramsPackage.register(registry);
 	}
@@ -110,5 +116,5 @@
 	@AutoAppendAnnotation
 	public void takeFromRegistry(Registry registry) {
-		log.debug("taking from registry " + registry + " in tree " + this);
+		log.debug("taking from registry {} in tree {}", registry, this);
 		this.registry.takeAllFrom(registry);
 	}
@@ -231,4 +237,51 @@
 	}
 
+
+	@SuppressWarnings("unchecked")
+	protected final Map<Object, Object> sideNotes = (Map<Object, Object>) new ReferenceIdentityMap(ReferenceIdentityMap.WEAK, ReferenceIdentityMap.HARD);
+
+	@Override
+	public void putSideNote(Object object, Object key, Object value) {
+		assert isActive();
+		Misc.throwIfNull(object);
+		Misc.throwIfNull(key);
+		Misc.throwIfNull(value);
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			sideNote = new ReferenceIdentityMap(ReferenceIdentityMap.WEAK, ReferenceIdentityMap.HARD);
+			sideNotes.put(object, sideNote);
+		}
+		@SuppressWarnings("unchecked")
+		Map<Object, Object> sideNotesMap = (Map<Object, Object>) sideNote;
+		sideNotesMap.put(key, value);
+	}
+
+	@Override
+	public <T> T getSideNote(Object object, Object key, Class<T> valueType) {
+		assert isActive();
+		Misc.throwIfNull(object);
+		Misc.throwIfNull(key);
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			return null;
+		}
+		return Casting.nullOrThrowCast(valueType, ((Map<?, ?>) sideNote).get(key));
+	}
+
+	@Override
+	public boolean removeSideNote(Object object, Object key) {
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			return false;
+		}
+		@SuppressWarnings("unchecked")
+		Map<Object, Object> sideNotesMap = (Map<Object, Object>) sideNote;
+		boolean result = (sideNotesMap.remove(key) != null);
+		if (sideNotesMap.isEmpty()) {
+			sideNotes.remove(object);
+		}
+		return result;
+	}
+
 }
 
Index: java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 100)
@@ -7,6 +7,6 @@
 import com.framsticks.util.dispatching.Monitor;
 
-import org.apache.log4j.Logger;
-import org.apache.log4j.PropertyConfigurator;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.io.InputStream;
@@ -17,10 +17,8 @@
 @FramsClassAnnotation
 public class Framsticks extends JoinableCollection<Joinable> {
-	private static final Logger log = Logger.getLogger(Framsticks.class);
+	private static final Logger log = LogManager.getLogger(Framsticks.class);
 
 	public Framsticks() {
-		PropertyConfigurator.configure(getClass().getResource("/configs/log4j.properties"));
 
-		// log.info("config is: " + System.getProperties().getProperty("framsticks.config", "/configs/framsticks.xml"));
 	}
 
Index: java/main/src/main/java/com/framsticks/core/ListChange.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 100)
@@ -3,4 +3,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.Misc;
 import com.framsticks.util.lang.Strings;
 
@@ -8,6 +9,22 @@
  * @author Piotr Sniegowski
  */
-@FramsClassAnnotation
+@FramsClassAnnotation(order = {"type", "pos", "id"})
 public class ListChange {
+
+
+	/**
+	 * @param action
+	 */
+	public ListChange(Action action, Integer position, String identifier) {
+		this.action = action;
+		this.position = position;
+		this.identifier = identifier;
+	}
+
+	/**
+	 *
+	 */
+	public ListChange() {
+	}
 
 	public Action getAction() {
@@ -37,5 +54,5 @@
 		//  */
 		// Action(int value) {
-		// 	this.value = value;
+		//	this.value = value;
 		// }
 
@@ -43,5 +60,5 @@
 
 	public Action action = Action.Add;
-	@ParamAnnotation(id = "pos")
+	@ParamAnnotation(id = "pos", def = "-1")
 	public Integer position;
 	@ParamAnnotation(id = "id")
@@ -64,3 +81,13 @@
 		return action + " " + identifier + " " + position;
 	}
+
+	@Override
+	public boolean equals(Object object) {
+		if (object instanceof ListChange) {
+			ListChange r = (ListChange) object;
+			return Misc.equals(action, r.action) && Misc.equals(position, r.position) && Misc.equals(identifier, r.identifier);
+		}
+		return false;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/core/LocalTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/LocalTree.java	(revision 100)
@@ -1,7 +1,8 @@
 package com.framsticks.core;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.EventListener;
@@ -9,5 +10,4 @@
 import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.params.ValueParam;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -21,5 +21,5 @@
 @FramsClassAnnotation
 public final class LocalTree extends AbstractTree {
-	private static final Logger log = Logger.getLogger(LocalTree.class);
+	private static final Logger log = LogManager.getLogger(LocalTree.class);
 
 	protected Object rootObject;
@@ -38,5 +38,5 @@
 		registry.registerAndBuild(javaClass);
 
-		AccessInterface access = registry.createAccess(javaClass);
+		Access access = registry.createAccess(javaClass);
 
 		assignRootParam(access.buildParam(new ParamBuilder()).id(getName()).finish(CompositeParam.class));
@@ -62,15 +62,15 @@
 	public void get(Path path, Future<Path> future) {
 		assert isActive();
-		log.debug("requesting: " + path);
+		log.debug("requesting: {}", path);
 		path = resolveTopSync(path);
 		future.pass(path);
 	}
 
-	@Override
-	public void get(Path path, ValueParam param, Future<Object> future) {
-		assert isActive();
-		path = resolveTopSync(path);
-		future.pass(bindAccess(path).get(param, Object.class));
-	}
+	// @Override
+	// public void get(Path path, ValueParam param, Future<Object> future) {
+	// 	assert isActive();
+	// 	path = resolveTopSync(path);
+	// 	future.pass(bindAccess(path).get(param, Object.class));
+	// }
 
 	@Override
@@ -103,5 +103,5 @@
 			return path;
 		}
-		AccessInterface access = bindAccess(path.getUnder());
+		Access access = bindAccess(path.getUnder());
 		Object object = access.get(path.getTop().getParam(), Object.class);
 		if (object == null) {
Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.core;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.Param;
@@ -25,5 +25,5 @@
 @Immutable
 public final class Path {
-	// private final static Logger log = Logger.getLogger(Path.class.getName());
+	// private final static Logger log = LogManager.getLogger(Path.class.getName());
 
 	final Tree tree;
@@ -31,5 +31,5 @@
 	final LinkedList<Node> nodes;
 
-	protected static Object getKnownChild(Tree tree, AccessInterface access, CompositeParam param, ExceptionResultHandler handler) {
+	protected static Object getKnownChild(Tree tree, Access access, CompositeParam param, ExceptionResultHandler handler) {
 		Object child = access.get(param, Object.class);
 		if (child == null) {
@@ -38,4 +38,5 @@
 		try {
 			tree.prepareAccess(param);
+			tree.putSideNote(child, CompositeParam.class, param);
 			return child;
 		} catch (FramsticksException e) {
@@ -151,5 +152,5 @@
 			Iterator<String> i = splitPath(textual);
 			while (i.hasNext() && current.getObject() != null) {
-				AccessInterface access = TreeOperations.bindAccess(current);// tree.prepareAccess(current.getParam());
+				Access access = TreeOperations.bindAccess(current);// tree.prepareAccess(current.getParam());
 				String e = i.next();
 				Param p = access.getParam(e);
@@ -163,4 +164,5 @@
 				b.append("/").append(e);
 				access.select(current.getObject());
+				tree.putSideNote(current.getObject(), CompositeParam.class, current.getParam());
 				current = new Node(current.getTree(), c, getKnownChild(tree, access, c, handler));
 				nodes.add(current);
Index: java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Tree.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/Tree.java	(revision 100)
@@ -3,5 +3,5 @@
 import javax.annotation.Nonnull;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.EventListener;
@@ -9,5 +9,4 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.Registry;
-import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
@@ -24,5 +23,5 @@
 	public void assignRootObject(Object object);
 
-	public @Nonnull AccessInterface prepareAccess(CompositeParam param);
+	public @Nonnull Access prepareAccess(CompositeParam param);
 	public void takeAllFrom(Registry source);
 
@@ -31,10 +30,10 @@
 	public void putInfoIntoCache(FramsClass framclass);
 
-	/**
-	 *
-	 * Functions accepts ValueParam, because it is also possible to get number of List elements.
-	 *
-	 */
-	public void get(Path path, ValueParam param, Future<Object> future);
+	// /**
+	//  *
+	//  * Functions accepts ValueParam, because it is also possible to get number of List elements.
+	//  *
+	//  */
+	// public void get(Path path, ValueParam param, Future<Object> future);
 
 	public void get(Path path, Future<Path> future);
@@ -65,3 +64,9 @@
 	public Registry getRegistry();
 
+	public void putSideNote(Object object, Object key, Object value);
+
+	public boolean removeSideNote(Object object, Object key);
+
+	public <T> T getSideNote(Object object, Object key, Class<T> valueType);
+
 }
